#!/usr/bin/python

import sys, os
from mod_python import MyOut, MyErr, Request, apache

def handle_request(environ, start_response):
	status = '404 File not found'
	output = ''
	os.chdir(os.path.dirname(environ['SCRIPT_FILENAME']))
	sys.path[0] = os.path.dirname(environ['SCRIPT_FILENAME'])
	response_headers = [('Content-Type', 'text/html')]
	python_handler = None
	if 'PythonHandler' in environ:
		python_handler = environ['PythonHandler']
	oldstdout = sys.stdout
	oldstderr = sys.stderr
	sys.stdout = MyOut()
	sys.stderr = MyErr(oldstdout)
	try:
		request = Request.create_request(environ, response_headers)
		if python_handler == None:
			execfile(environ['SCRIPT_FILENAME'])
			status = '200 OK'
		else:
			py = __import__(python_handler, 'py')
			state = py.handler(request)
			if state == apache.OK:
				status = '200 OK'
			elif state == apache.HTTP_MOVED_TEMPORARILY:
				status = '301 Moved temporarily'
			elif state == apache.HTTP_MOVED_PERMANENTLY:
				status = '302 Moved permanently'
			elif state == apache.HTTP_UNAUTHORIZED:
				status = '401 Unauthorized'
			elif state == apache.HTTP_FORBIDDEN:
				status = '403 Forbidden'
	except:
		sys.stderr.write('exception:')
		status = '500 Server error'
		raise
	output = sys.stdout.read()
	sys.stdout = oldstdout
	sys.stderr = oldstderr
	start_response(status, response_headers)
	return output
