#!/usr/bin/python

import sys

class MyOut(object):
	def __init__(self):
		self.log = []

	def write(self, message):
		self.log += [message]

	def read(self):
		return self.log

class MyErr(object):
	def __init__(self, oldout):
		self.log = []
		self.oldout = oldout

	def write(self, message):
		backupout = sys.stdout
		sys.stdout = self.oldout
		print "%s" % message
		sys.stdout = backupout

class Apache(object):
	OK = 200
	HTTP_MOVED_TEMPORARILY = 301
	HTTP_MOVED_PERMANENTLY = 302
	HTTP_UNAUTHORIZED = 401
	HTTP_FORBIDDEN = 403
	HTTP_NOT_FOUND = 404
	SERVER_RETURN = 500		# stub likely needs to be some kind of Exception handler
	APLOG_WARNING = "warning"	# stub
	APLOG_ERR = "error"		# stub
	def __init__(self):
		self.r = None

	def log_error(self, message, level):
		sys.stderr.write("error(%s): '%s'" % (level, message))

apache = Apache()

class Headers(object):
	def __init__(self, headers):
		self.headers = headers

	def add(self, name, value):
		self.headers.append( (name, value) )

request = None

class Request(object):
	env = {}
	uri = ''
	def __init__(self, environ, headers):
		sys.stderr.write("stub: %s.%s" % (self.__class__.__name__, sys._getframe().f_code.co_name))
		self.env = environ
		self.headers = headers
		self.uri = environ['SCRIPT_NAME']
		if 'REMOTE_USER' in environ:
			self.user = environ['REMOTE_USER']
		else:
			self.user = None
		self.headers_in = {}
		self.headers_out = Headers(self.headers)

	def write(self, message, level):
		if level != 0:
			sys.stderr.write("message(%d): '%s'" % (level, message))
		sys.stdout.write(message)
	
	@staticmethod
	def create_request(environ, headers):
		request = Request(environ, headers)
		return request

class Field:
	def __init__(self, name, value):
		self.name = name
		self.value = value

class Fields:
	def __init__(self, list):
		self.list = []
		for p,v in list:
			self.list.append(Field(p, v))

class Util(object):
	def __init__(self):
		self.r = None

	def parse_qs(self, req, keep_empty = False):
		list = []
		for line in req.env['QUERY_STRING'].split('&'):
			if len(line) > 0:
				v = line.split('=')
				if len(v) > 1 and len(v[0]) > 0:
					list.append( (v[0], '='.join(v[1:])) )
				elif keep_empty and len(v[0]) > 0:
					list.append( (v[0], '') )
		return list

	def FieldStorage(self, req, keep_blank_values = 1):
		fields = Fields(self.parse_qs(req, keep_blank_values != 0))
		return fields

util = Util()

cookies = []

class Cookie(object):
	def __init__(self, varname, value, path = '/'):
		sys.stderr.write("stub: %s.%s" % (self.__class__.__name__, sys._getframe().f_code.co_name))
		self.varname = varname
		self.value = value
		self.path = path
		cookies.append(self)

	@staticmethod
	def get_cookies(req):
		sys.stderr.write("stub: %s" % sys._getframe().f_code.co_name)
		return cookies

